package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 工厂仓库
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-09-04 15:58
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name="WH_STOCK_AREA")
@Api("仓库区域")
public class StockArea extends BaseBean {

    @Column(name="AREA_CODE")
    @ApiParam("仓库区域代码")
    public String areaCode;

    @Column(name="AREA_NAME")
    @ApiParam("仓库区域名称")
    public String areaName;

    @Column(name="WH_ID")
    @ApiParam(value = "仓库编号", example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    public Long whId;

    @Column(name="WH_CODE_RDD")
    @ApiParam("仓库代码")
    public String whCodeRdd;

    @Column(name="WH_NAME_RDD")
    @ApiParam("仓库名称")
    public String whNameRdd;

    public Long getWhId() {
        if(whId != null) {
            return whId.longValue();
        }else{
            return whId;
        }
    }

}
