package cn.estsh.i3plus.pojo.wms.sqlpack;

import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.wms.bean.*;
import cn.estsh.i3plus.pojo.wms.bean.InterfaceDevice;
import cn.estsh.i3plus.pojo.wms.bean.WareHouse;
import cn.estsh.i3plus.pojo.wms.bean.WmsTrans;
import cn.estsh.i3plus.pojo.wms.bean.WmsTransType;

/**
 * @Description : 仓库管理对象封装
 * @Reference :
 * @Author : silliter.yuan
 * @CreateDate : 2018-10-31 10:45
 * @Modify:
 **/
public class WmsHqlPack {

    /**
     * 工厂仓库模糊分页查询
     * @param wareHouse
     * @return
     */
    public static String packHqlFactoryStore(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();

        // 部门名称
        HqlPack.getStringLikerPack(wareHouse.getCode(),"code", result);
        // 部门代码
        HqlPack.getStringLikerPack(wareHouse.getName(),"name", result);

        return result.toString();
    }

    public static String packHqlWmsButton(WmsButton wmsButton) {
        StringBuffer result = new StringBuffer();

        // 功能名称（name）
        HqlPack.getStringLikerPack(wmsButton.getName(),"name", result);
        // 前端实现（ui）
        HqlPack.getStringLikerPack(wmsButton.getUi(),"ui", result);
        // URI权限规则（bs）
        HqlPack.getStringLikerPack(wmsButton.getBs(),"bs", result);

        return result.toString();
    }

    /**
     *  接口驱动类信息 分页查询
     * @return
     */
    public static String packHqlInterfaceDevice(InterfaceDevice interfaceDevice){
        StringBuffer sb = new StringBuffer();
        //驱动类名称
        HqlPack.getStringEqualPack(interfaceDevice.getDeviceClassName(),"deviceClassName",sb);

        return null;
    }

    /**
     * 元数据信息 分页查询
     * @param wmsObject
     * @return
     */
    public static String packHqlWmsObject(WmsObject wmsObject){
        StringBuffer result = new StringBuffer();

        // 编码
        HqlPack.getStringLikerPack(wmsObject.getCode(),"code",result);
       // 名称
        HqlPack.getStringEqualPack(wmsObject.getName(),"name",result);
        // 数据主表
        HqlPack.getStringEqualPack(wmsObject.getTableName(),"tableName",result);
        // 自定义业务拦截
        HqlPack.getStringEqualPack(wmsObject.getBizIntercept(),"bizIntercept",result);

        return result.toString();
    }

    /**
     * 元数据字段分页查询
     * @param wmsField
     * @return
     */
    public static String packHqlWmsField(WmsField wmsField){
        StringBuffer result = new StringBuffer();
        // 编码
        HqlPack.getStringLikerPack(wmsField.getObjectCode(),"objectCode",result);
        HqlPack.getStringLikerPack(wmsField.getTableName(),"tableName",result);
        return result.toString();
    }


    /**
     * 交易类型信息 分页查询
     * @param wmsTransType
     * @return
     */
    public static String packHqlWmsTransType(WmsTransType wmsTransType) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getNumEqualPack(wmsTransType.getIsValid(),"isValid",result);
        HqlPack.getStringLikerPack(wmsTransType.getTransCode(),"transCode",result);
        HqlPack.getStringLikerPack(wmsTransType.getTransName(),"transName",result);

        return result.toString();
    }

    /**
     * 库存交易记录信息 分页查询
     * @param wmsTrans
     * @return
     */
    public static String packHqlWmsTrans(WmsTrans wmsTrans) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringEqualPack(wmsTrans.getTransCode(),"transCode",result);
        HqlPack.getStringEqualPack(wmsTrans.getSn(),"sn",result);
        HqlPack.timeBuilder(wmsTrans.getCreateDatetime(),null,"createDatetime",result,true);

        return result.toString();
    }

    /**
     * 仓库分页查询条件
     * @param wareHouse
     * @return
     */
    public static String packHqlWareHouse(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wareHouse.getAddress(), "address", result);
        HqlPack.getStringLikerPack(wareHouse.getCode(), "code", result);
        HqlPack.getStringLikerPack(wareHouse.getName(), "name", result);
        // 默认有效
        if(wareHouse.getIsValid()==null){
            HqlPack.getStringEqualPack(CommonEnumUtil.IS_VAILD.VAILD.getValue()+"","isValid",result);
        }else{
            HqlPack.getStringEqualPack(CommonEnumUtil.IS_VAILD.INVAILD.getValue()+"","isValid",result);
        }
        return result.toString();
    }

    /**
     * 供应商分页查询
     * @param basVendor
     * @return
     */
    public static String packHqlBasVendor(BasVendor basVendor){
        StringBuffer result = new StringBuffer();

        HqlPack.getStringLikerPack(basVendor.getVendorNo(), "vendorNo", result);
        HqlPack.getStringLikerPack(basVendor.getVendorName(), "vendorName", result);
        HqlPack.getStringLikerPack(basVendor.getVendorOwner(), "vendorOwner", result);
        HqlPack.getStringLikerPack(basVendor.getVendorDesc(), "vendorDesc", result);
        HqlPack.getStringLikerPack(basVendor.getVendorAddr(), "vendorAddr", result);
        HqlPack.getStringLikerPack(basVendor.getVendorEmail(), "vendorEmail", result);
        if(basVendor.getIsAsn()!= null){
            HqlPack.getStringLikerPack(basVendor.getIsAsn().toString(), "isAsn", result);
        }
        HqlPack.getNumEqualPack(basVendor.getIsValid(),"isValid",result);
        return result.toString();
    }

    /**
     * 作业类型分页查询
     * @param wmsOpType
     * @return
     */
    public static String packHqlWmsOpType(WmsOpType wmsOpType){
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeCode(), "opTypeCode", result);
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeName(),"opTypeName",result);
        HqlPack.getStringLikerPack(wmsOpType.getSeq().toString(),"seq",result);
        HqlPack.getStringLikerPack(wmsOpType.getProCode(),"proCode",result);
        HqlPack.getNumEqualPack(wmsOpType.getIsValid(),"isValid",result);
        return result.toString();
    }

    /**
     * 仓库唯一性校验查询条件【用于添加和修改】
     * @param wareHouse
     * @return
     */
    public static String packHqlWareHouseUnique(WareHouse wareHouse){
        StringBuffer result = new StringBuffer();
        HqlPack.getStringEqualPack(wareHouse.getName(), "name", result);
        HqlPack.getStringEqualPack(wareHouse.getCode(), "code", result);
        HqlPack.getNumNOEqualPack(wareHouse.getId(), "id", result);
        return result.toString();
    }

    /**
     * 供应商唯一性校验查询条件【用于添加和修改】
     * @param basVendor
     * @return
     */
    public static String packHqlBasVendorUnique(BasVendor basVendor){
        StringBuffer result = new StringBuffer();
        if(basVendor.getId()!=null){
            HqlPack.getNumNOEqualPack(basVendor.getId(), "id", result);
        }
        HqlPack.getStringEqualPack(basVendor.getVendorNo(), "vendorNo", result);
        HqlPack.getStringEqualPack(basVendor.getVendorName(), "vendorName", result);
        HqlPack.getStringEqualPack(basVendor.getVendorDesc(), "vendorDesc", result);
        return result.toString();
    }

    public static String packHqlWmsOpTypeUnique(WmsOpType wmsOpType){
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeCode(), "opTypeCode", result);
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeName(),"opTypeName",result);
        return result.toString();
    }
}
